package GererPretSA;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import java.sql.*;

public class ServletIdentificationExemplaire extends HttpServlet {

  public void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
    //Chercher le paramtre idUtilisateur de la form
    String idExemplaire = "";
    try { idExemplaire = request.getParameter("idExemplaire"); }
    catch (Exception e) { e.printStackTrace(); }

    // Chercher l'objet de la session en cours
    HttpSession uneSession = request.getSession(false);
    
    // Chercher les objets du contexte de la session en cours
    Connection uneConnection = (Connection)uneSession.getAttribute("uneConnection");
    Utilisateur unUtilisateur = (Utilisateur)uneSession.getAttribute("unUtilisateur");
    CourtierBDPretEnCours unCourtierBDPretEnCours =
      (CourtierBDPretEnCours)uneSession.getAttribute("unCourtierBDPretEnCours");

    // Entete de la page de reponse html
    response.setContentType("text/html");
    OutputStreamWriter unOutputStreamWriter =
      new OutputStreamWriter(response.getOutputStream());
    PrintWriter out = new PrintWriter(unOutputStreamWriter);
      out.println("<html>");
      out.println("<head><title>Reponse de ServletIdentificationExemplaire</title></head>");
      out.println("<body>");

    try{
        // Verifier statut de l'exemplaire
        CourtierBDExemplaire unCourtierBDExemplaire =
          new CourtierBDExemplaire(uneConnection);
        Exemplaire unExemplaire =
          unCourtierBDExemplaire.chercherExemplaireParIdExemplaire(idExemplaire);
        if (unExemplaire.getStatut().equals("disponible")){

          // Generer la date du jour et l'objet PretEnCours
          Calendar maintenant = Calendar.getInstance(); // Calendrier avec date actuelle
          java.sql.Date dateMaintenant = new java.sql.Date(maintenant.getTime().getTime());
          PretEnCours leNouveauPretEnCours = new PretEnCours(unUtilisateur,dateMaintenant,unExemplaire);

          // Materialiser le PretEnCours dans la BD
          unCourtierBDPretEnCours.insererPretEnCours(leNouveauPretEnCours);

          // Message de confirmation du pret
          out.println("Pret de l'exemplaire " + idExemplaire +
                "  l'utilisateur " + unUtilisateur.getIdUtilisateur() +
                " confirme.<br>Date :" + dateMaintenant);
        }else{
          // Message indiquant que l'exemplaire n'est pas disponible pour le pret
          out.println("Exemplaire non disponible:"+idExemplaire);
        }
    }catch (Exception e) {
      out.println(e.getMessage());
      e.printStackTrace();
    }
    finally{
      try{
        out.println("</body></html>");
        out.close();
        uneConnection.commit();
        uneConnection.close();
      }
      catch(Exception lException){
        lException.printStackTrace();
      }
    }
  }
}